using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Data.OleDb;

namespace Album_Catalog
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class fclsMain : System.Windows.Forms.Form
	{
		private System.Windows.Forms.ImageList imgMain;
		private System.Windows.Forms.MainMenu mnuMain;
		private System.Windows.Forms.MenuItem mnuFile;
		private System.Windows.Forms.MenuItem mnuNewAlbum;
		private System.Windows.Forms.MenuItem mnuDeleteAlbum;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem mnuQuit;
		private System.Windows.Forms.MenuItem mnuEdit;
		private System.Windows.Forms.MenuItem mnuEditAlbum;
		private System.Windows.Forms.ToolBar tbMain;
		private System.Windows.Forms.ToolBarButton tbbOpenDatabase;
		private System.Windows.Forms.ToolBarButton tbbSeparator1;
		private System.Windows.Forms.ToolBarButton tbbNewAlbum;
		private System.Windows.Forms.ToolBarButton tbbEditAlbum;
		private System.Windows.Forms.ToolBarButton tbbDeleteAlbum;
		private System.Windows.Forms.ListView lvwAlbums;
		private System.Windows.Forms.ColumnHeader colAlbumName;
		private System.Windows.Forms.ColumnHeader colArtistName;
		private System.Windows.Forms.ColumnHeader colArtWorkFileName;
		private System.Windows.Forms.OpenFileDialog ofdChooseDatabase;
		private System.ComponentModel.IContainer components;
		string m_strDatabase;

		public fclsMain()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(fclsMain));
			this.imgMain = new System.Windows.Forms.ImageList(this.components);
			this.mnuMain = new System.Windows.Forms.MainMenu();
			this.mnuFile = new System.Windows.Forms.MenuItem();
			this.mnuNewAlbum = new System.Windows.Forms.MenuItem();
			this.mnuDeleteAlbum = new System.Windows.Forms.MenuItem();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.mnuQuit = new System.Windows.Forms.MenuItem();
			this.mnuEdit = new System.Windows.Forms.MenuItem();
			this.mnuEditAlbum = new System.Windows.Forms.MenuItem();
			this.tbMain = new System.Windows.Forms.ToolBar();
			this.tbbOpenDatabase = new System.Windows.Forms.ToolBarButton();
			this.tbbSeparator1 = new System.Windows.Forms.ToolBarButton();
			this.tbbNewAlbum = new System.Windows.Forms.ToolBarButton();
			this.tbbEditAlbum = new System.Windows.Forms.ToolBarButton();
			this.tbbDeleteAlbum = new System.Windows.Forms.ToolBarButton();
			this.lvwAlbums = new System.Windows.Forms.ListView();
			this.colAlbumName = new System.Windows.Forms.ColumnHeader();
			this.colArtistName = new System.Windows.Forms.ColumnHeader();
			this.colArtWorkFileName = new System.Windows.Forms.ColumnHeader();
			this.ofdChooseDatabase = new System.Windows.Forms.OpenFileDialog();
			this.SuspendLayout();
			// 
			// imgMain
			// 
			this.imgMain.ImageSize = new System.Drawing.Size(16, 16);
			this.imgMain.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imgMain.ImageStream")));
			this.imgMain.TransparentColor = System.Drawing.Color.Silver;
			// 
			// mnuMain
			// 
			this.mnuMain.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					this.mnuFile,
																					this.mnuEdit});
			// 
			// mnuFile
			// 
			this.mnuFile.Index = 0;
			this.mnuFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					this.mnuNewAlbum,
																					this.mnuDeleteAlbum,
																					this.menuItem1,
																					this.mnuQuit});
			this.mnuFile.Text = "&File";
			// 
			// mnuNewAlbum
			// 
			this.mnuNewAlbum.Index = 0;
			this.mnuNewAlbum.Shortcut = System.Windows.Forms.Shortcut.CtrlN;
			this.mnuNewAlbum.Text = "&New Album";
			this.mnuNewAlbum.Click += new System.EventHandler(this.mnuNewAlbum_Click);
			// 
			// mnuDeleteAlbum
			// 
			this.mnuDeleteAlbum.Index = 1;
			this.mnuDeleteAlbum.Text = "&Delete Album";
			this.mnuDeleteAlbum.Click += new System.EventHandler(this.mnuDeleteAlbum_Click);
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 2;
			this.menuItem1.Text = "-";
			// 
			// mnuQuit
			// 
			this.mnuQuit.Index = 3;
			this.mnuQuit.Shortcut = System.Windows.Forms.Shortcut.CtrlQ;
			this.mnuQuit.Text = "&Quit";
			this.mnuQuit.Click += new System.EventHandler(this.mnuQuit_Click);
			// 
			// mnuEdit
			// 
			this.mnuEdit.Index = 1;
			this.mnuEdit.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					this.mnuEditAlbum});
			this.mnuEdit.Text = "&Edit";
			// 
			// mnuEditAlbum
			// 
			this.mnuEditAlbum.Index = 0;
			this.mnuEditAlbum.Text = "&Edit Album";
			this.mnuEditAlbum.Click += new System.EventHandler(this.mnuEditAlbum_Click);
			// 
			// tbMain
			// 
			this.tbMain.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																					  this.tbbOpenDatabase,
																					  this.tbbSeparator1,
																					  this.tbbNewAlbum,
																					  this.tbbEditAlbum,
																					  this.tbbDeleteAlbum});
			this.tbMain.DropDownArrows = true;
			this.tbMain.ImageList = this.imgMain;
			this.tbMain.Location = new System.Drawing.Point(0, 0);
			this.tbMain.Name = "tbMain";
			this.tbMain.ShowToolTips = true;
			this.tbMain.Size = new System.Drawing.Size(292, 28);
			this.tbMain.TabIndex = 0;
			this.tbMain.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.tbMain_ButtonClick);
			// 
			// tbbOpenDatabase
			// 
			this.tbbOpenDatabase.ImageIndex = 0;
			this.tbbOpenDatabase.ToolTipText = "Open Database";
			// 
			// tbbSeparator1
			// 
			this.tbbSeparator1.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// tbbNewAlbum
			// 
			this.tbbNewAlbum.ImageIndex = 1;
			this.tbbNewAlbum.ToolTipText = "New Album";
			// 
			// tbbEditAlbum
			// 
			this.tbbEditAlbum.ImageIndex = 3;
			this.tbbEditAlbum.ToolTipText = "Edit Album";
			// 
			// tbbDeleteAlbum
			// 
			this.tbbDeleteAlbum.ImageIndex = 2;
			this.tbbDeleteAlbum.ToolTipText = "Delete Album";
			// 
			// lvwAlbums
			// 
			this.lvwAlbums.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lvwAlbums.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																						this.colAlbumName,
																						this.colArtistName,
																						this.colArtWorkFileName});
			this.lvwAlbums.FullRowSelect = true;
			this.lvwAlbums.HideSelection = false;
			this.lvwAlbums.Location = new System.Drawing.Point(6, 32);
			this.lvwAlbums.MultiSelect = false;
			this.lvwAlbums.Name = "lvwAlbums";
			this.lvwAlbums.Size = new System.Drawing.Size(277, 224);
			this.lvwAlbums.SmallImageList = this.imgMain;
			this.lvwAlbums.Sorting = System.Windows.Forms.SortOrder.Ascending;
			this.lvwAlbums.TabIndex = 1;
			this.lvwAlbums.View = System.Windows.Forms.View.Details;
			this.lvwAlbums.DoubleClick += new System.EventHandler(this.lvwAlbums_DoubleClick);
			// 
			// colAlbumName
			// 
			this.colAlbumName.Text = "Album";
			this.colAlbumName.Width = 160;
			// 
			// colArtistName
			// 
			this.colArtistName.Text = "Artist";
			this.colArtistName.Width = 100;
			// 
			// colArtWorkFileName
			// 
			this.colArtWorkFileName.Text = "ArtWorkFileName";
			this.colArtWorkFileName.Width = 0;
			// 
			// ofdChooseDatabase
			// 
			this.ofdChooseDatabase.Filter = "Microsoft Access Databases|*.mdb";
			this.ofdChooseDatabase.Title = "Open Database";
			// 
			// fclsMain
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 266);
			this.Controls.Add(this.lvwAlbums);
			this.Controls.Add(this.tbMain);
			this.Menu = this.mnuMain;
			this.Name = "fclsMain";
			this.Text = "Album Catalog";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		
		void ShowAlbums()
		{
			OleDbConnection cnADONetConnection = new OleDbConnection();
			OleDbDataAdapter daDataAdapter = new OleDbDataAdapter();
			OleDbCommandBuilder cbCommandBuilder;
			DataTable dtAlbums = new DataTable();
			int rowPosition = 0;

			try
			{
				// Open the database.
				cnADONetConnection.ConnectionString = 
					@"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + m_strDatabase;
				
				cnADONetConnection.Open();

				// Get all albums.
				daDataAdapter = 
					new OleDbDataAdapter("Select * From tblCDs", 
					cnADONetConnection);

				daDataAdapter.Fill(dtAlbums);

				// Set up the command builder for navigation.
				cbCommandBuilder = 
					new OleDbCommandBuilder(daDataAdapter);


				// Clear the list.
				lvwAlbums.Items.Clear();

				// Go through the recordset and show all of the CDs/albums
				ListViewItem objListItem;
			
				while (rowPosition < dtAlbums.Rows.Count)
				{
					// Create a new list item for the album.
					objListItem = lvwAlbums.Items.Add( 
						dtAlbums.Rows[rowPosition]["Title"].ToString(), 0);

					objListItem.SubItems.Add( 
						dtAlbums.Rows[rowPosition]["ArtistName"].ToString());

					objListItem.SubItems.Add( 
						dtAlbums.Rows[rowPosition]["ArtWorkFileName"].ToString());

					// If artwork is present, indicate this with an icon.
					if (dtAlbums.Rows[rowPosition]["ArtWorkFileName"].
						ToString().Length > 0)
					{
						// Show the image of the camera to denote there is 
						// an image for this album.
						objListItem.ImageIndex = 5;
					}
					else
						objListItem.ImageIndex = -1;

					rowPosition = rowPosition + 1;
				}	// End While
			
				// Close the connection.
				cnADONetConnection.Close();
			}
			catch (Exception ex)
			{
				MessageBox.Show("An error has occurred! Error: " + ex.Message, 
					"Album Catalog", MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
 
		}

		void NewAlbum()
		{
			try
			{	
				// Make sure a database is loaded.
				if (m_strDatabase == "")
				{
					MessageBox.Show("No database has been opened.", 
						"Album Catalog", MessageBoxButtons.OK,
						MessageBoxIcon.Exclamation);
					return;
				}
		
				// Load the album maintenance form and let it know
				// the user is entering a new album
				fclsAlbum frmAlbum = new fclsAlbum();
				frmAlbum.Database = m_strDatabase;
				frmAlbum.ShowDialog();

				// Refresh the album list.
				ShowAlbums();
			}
			catch (Exception ex)
			{
				MessageBox.Show("An error has occurred! Error: " + ex.Message, 
					"Album Catalog", MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
		}

		void EditAlbum()
		{
			try
			{
				// Make sure an album has been selected.
				if (lvwAlbums.SelectedItems.Count == 0)
				{
					MessageBox.Show("There is no album selected.", 
						"Album Catalog", MessageBoxButtons.OK, 
						MessageBoxIcon.Information);
					return;
				}

				// Load the album maintenance form and let it know
				// which album is being edited.
				fclsAlbum frmAlbum = new fclsAlbum();
				frmAlbum.Database = m_strDatabase;
				frmAlbum.ShowAlbum(lvwAlbums.SelectedItems[0].Text, 
					lvwAlbums.SelectedItems[0].SubItems[1].Text, 
					lvwAlbums.SelectedItems[0].SubItems[2].Text);
				frmAlbum.ShowDialog();

				// Refresh the album list.
				ShowAlbums();
			}
			catch (Exception ex)
			{
				MessageBox.Show("An error has occurred! Error: " + ex.Message, 
					"Album Catalog", MessageBoxButtons.OK, 
					MessageBoxIcon.Error);
			}
		}
		
		void DeleteAlbum()
		{
			OleDbConnection cnADONetConnection = new OleDbConnection();
			OleDbDataAdapter daDataAdapter = new OleDbDataAdapter();
			DataTable dtAlbums = new DataTable();
			OleDbCommandBuilder cbCommandBuilder;

			try
			{
				// Make sure an album has been selected.
				if (lvwAlbums.SelectedItems.Count == 0)
				{
					MessageBox.Show("There is no album selected.", 
						"Album Catalog", MessageBoxButtons.OK, 
						MessageBoxIcon.Information);
					return;
				}

				// Open the database.
				cnADONetConnection.ConnectionString = 
					@"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + m_strDatabase;
				cnADONetConnection.Open();

				// Find the album in the database.
				daDataAdapter = new OleDbDataAdapter("SELECT * From tblCDs " +
					"WHERE Title = '" + lvwAlbums.SelectedItems[0].Text + 
					"' AND " + "ArtistName = '" +
					lvwAlbums.SelectedItems[0].SubItems[1].Text +
					"'", cnADONetConnection);
				daDataAdapter.Fill(dtAlbums);

				// Set up the command builder so we can delete a record.
				cbCommandBuilder = new OleDbCommandBuilder(daDataAdapter);

				// Delete the album.
				dtAlbums.Rows[0].Delete();
				// Commit the changes to the actual data source.
				daDataAdapter.Update(dtAlbums);

				// Remove the album from the list.
				lvwAlbums.Items.Remove(lvwAlbums.SelectedItems[0]);
			}
			catch (Exception ex)
			{
				MessageBox.Show("An error has occurred! Error: " + ex.Message, 
					"Album Catalog", MessageBoxButtons.OK, 
					MessageBoxIcon.Error);
			}
   		}

		

		static void Main() 
		{
			Application.Run(new fclsMain());
		}

		private void mnuNewAlbum_Click(object sender, System.EventArgs e)
		{
			NewAlbum();
		}

		private void mnuEditAlbum_Click(object sender, System.EventArgs e)
		{
			EditAlbum();
		}

		private void mnuDeleteAlbum_Click(object sender, System.EventArgs e)
		{
			DeleteAlbum();
		}

		private void mnuQuit_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void tbMain_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
			try
			{
				if (e.Button == tbbOpenDatabase)
					OpenDatabase();
				else if (e.Button == tbbNewAlbum)
					NewAlbum();
				else if (e.Button == tbbDeleteAlbum)
					DeleteAlbum();
				else if (e.Button == tbbEditAlbum)
					EditAlbum();
			}
			catch (Exception ex)
			{
				MessageBox.Show("An error has occurred! Error: " + ex.Message, 
					"Album Catalog", MessageBoxButtons.OK, 
					MessageBoxIcon.Error);
			}

		}

		void OpenDatabase()
		{
			try
			{
				// Let the user browse for and select a database.
				ofdChooseDatabase.ShowDialog();
				if (ofdChooseDatabase.FileName != "")
				{
					m_strDatabase = ofdChooseDatabase.FileName;
					ShowAlbums();
				}
			}
			catch (Exception ex)
			{
				MessageBox.Show("An error has occurred! Error: " + ex.Message, 
					"Album Catalog", MessageBoxButtons.OK, 
					MessageBoxIcon.Error);
			}
		}

		private void lvwAlbums_DoubleClick(object sender, System.EventArgs e)
		{
			EditAlbum();
		}

		
	}
}
